#!/usr/bin/perl
# $Id: decrypt.pl,v 1.16 2011/02/07 08:36:35 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# decryption sample
#

use PDFlib::PLOP 4.1;

# parameters for the input document
my $in_filename = "PLOP-datasheet.pdf";
my $in_password = "DEMO";

# parameters for the output document
my $out_filename = "PLOP-datasheet-decrypted.pdf";
my $out_master = "";
my $out_user = "";
my $permissions = "";

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";


my $doc;
# create a new PLOP object
my $plop = new PDFlib::PLOP;

eval {
    my $optlist;

    $optlist = sprintf("searchpath={%s}", $searchpath);
    $plop->set_option($optlist);

    # open protected input file with the password
    $optlist = sprintf("password {%s} ", $in_password);
    if (($doc = $plop->open_document($in_filename, $optlist)) == -1)
    {
	printf("Error: %s", $plop->get_errmsg());
	$plop->delete();
	exit;
    }

    # create the output file
    $optlist = sprintf("masterpassword {%s} userpassword {%s} permissions {%s}",
    		$out_master, $out_user, $permissions);
    if ($plop->create_file($out_filename, $optlist)== -1)
    {
	printf("Error: %s", $plop->get_errmsg());
	$plop->delete();
	exit;
    }

    # close input and output files
    $plop->close_document($doc);
};
if ($@) {
    die("$0: PLOP Exception occurred:\n$@");
}
