#!/usr/bin/perl
# $Id: noprint.pl,v 1.16 2011/02/07 08:36:36 rjs Exp $
#
# PDFlib PLOP: PDF Linearization, Optimization, Protection
# sample for setting permissions
#

use PDFlib::PLOP 4.1;

# parameters for the input document
my $in_filename = "PLOP-datasheet.pdf";
my $in_password = "";

# parameters for the output document
my $out_filename = "PLOP-datasheet-noprint.pdf";
my $out_master = "DEMO";
my $out_user = "";

# You can add more permission strings here
my $permissions = "noprint nocopy";

# This is where input files live. Adjust as necessary.
my $searchpath = "../data";

my $doc;
# create a new PLOP object
my $plop = new PDFlib::PLOP;

eval {
    my $optlist;

    $optlist = sprintf("searchpath={%s}", $searchpath);
    $plop->set_option($optlist);

    # open unprotected input document without any password
    $optlist = sprintf("password {%s} ", $in_password);
    if (($doc = $plop->open_document($in_filename, $optlist)) == -1)
    {
	die("Error: %s", $plop->get_errmsg());
    }

    # create the output file and apply permission settings
    $optlist = sprintf("masterpassword {%s} userpassword {%s} permissions {%s}", $out_master, $out_user, $permissions);
    if ($plop->create_file($out_filename, $optlist)== -1)
    {
	die("Error: %s", $plop->get_errmsg());
    }

    # close input and output files
    $plop->close_document($doc);
};
if ($@) {
    die("$0: PLOP Exception occurred:\n$@");
}
